package fi.flexplex.connect;

import com.destroystokyo.paper.event.server.WhitelistToggleEvent;
import com.destroystokyo.paper.profile.ProfileProperty;

import org.bukkit.Bukkit;
import org.bukkit.event.EventHandler;
import org.bukkit.event.EventPriority;
import org.bukkit.event.Listener;
import org.bukkit.event.player.AsyncPlayerPreLoginEvent;

import fi.flexplex.connect.event.AsyncWhitelistChangedEvent;

public final class FlexConnectListener implements Listener {
    
    private final FlexConnect flexConnect;

    public FlexConnectListener(final FlexConnect flexConnect) {
        this.flexConnect = flexConnect;
    }

    @EventHandler
    public void onAsyncPlayerPreLogin(final AsyncPlayerPreLoginEvent event) {
        // Authenticate players
        for (final ProfileProperty property : event.getPlayerProfile().getProperties()) {
            if (property.getName().equals("flexplex-token") && property.getValue().equals(flexConnect.getToken())) {
                // Authentication success
                return;
            }
        }
        // Authentication failed
        event.disallow(AsyncPlayerPreLoginEvent.Result.KICK_OTHER, "Access denied");
    }

    @EventHandler(ignoreCancelled = true, priority = EventPriority.MONITOR)
    public void onWhitelistToggle(final WhitelistToggleEvent event) {
        Bukkit.getScheduler().runTaskAsynchronously(this.flexConnect, () -> 
            this.flexConnect.getFlexPlexGraphQLApi().updateWhitelist(event.isEnabled())
        );
    }

    @EventHandler
    public void onAsyncWhitelistChanged(final AsyncWhitelistChangedEvent event) {
        this.flexConnect.getFlexPlexGraphQLApi().updateWhitelist();
    }

}
